/*
 * Copyright 1999-2017 Alibaba Group Holding Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.alibaba.polardbx.druid.sql.dialect.mysql.ast.statement;

import com.alibaba.polardbx.druid.sql.ast.SQLName;
import com.alibaba.polardbx.druid.sql.ast.statement.SQLAlterDatabaseItem;
import com.alibaba.polardbx.druid.sql.dialect.mysql.ast.MySqlObjectImpl;
import com.alibaba.polardbx.druid.sql.dialect.mysql.visitor.MySqlASTVisitor;

public class MySqlAlterDatabaseKillJob extends MySqlObjectImpl implements SQLAlterDatabaseItem {

    private SQLName jobType;
    private SQLName jobId;

    @Override
    public void accept0(MySqlASTVisitor visitor) {
        if (visitor.visit(this)) {
            acceptChild(visitor, jobType);
            acceptChild(visitor, jobId);
        }
        visitor.endVisit(this);
    }

    public SQLName getJobType() {
        return jobType;
    }

    public void setJobType(SQLName jobType) {
        this.jobType = jobType;
    }

    public SQLName getJobId() {
        return jobId;
    }

    public void setJobId(SQLName jobId) {
        this.jobId = jobId;
    }
}
